<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Built-in path tools | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-6-0">Version 6.0</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a> &gt; <span class="breadcrumb">Built-in path tools</span>
   </div>
   <h2 id="built-in-path-tools"><a class="anchor" href="#"></a>Built-in path tools</h2>
   <div class="paragraph">
    <p>This page describes the built-in I/O tools:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#abspath-tool">abspath</a></p></li>
     <li>
      <p><a href="#basename-tool">basename</a></p></li>
     <li>
      <p><a href="#chdir-tool">chdir</a></p></li>
     <li>
      <p><a href="#chfileext-tool">chfileext</a></p></li>
     <li>
      <p><a href="#curdir-tool">curdir</a></p></li>
     <li>
      <p><a href="#dirname-tool">dirname</a></p></li>
     <li>
      <p><a href="#fileext-tool">fileext</a></p></li>
     <li>
      <p><a href="#hasfileext-tool">hasfileext</a></p></li>
     <li>
      <p><a href="#pathjoin-tool">pathjoin</a></p></li>
     <li>
      <p><a href="#scriptpath-tool">scriptpath</a></p></li>
    </ul>
   </div>
   <div class="sect4">
    <h3 id="abspath-tool"><a class="anchor" href="#abspath-tool"></a>abspath tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string abspath(string path)
tool string abspath(string path, string workdir)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns an absolute local file system path, given an absolute or relative local file system path.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>workdir</code>
      </dt>
      <dd>
       <p>The optional absolute local file system path of the working directory against which to resolve relative paths. May contain both <code>\</code> and <code>/</code> as file separators. If not specified, relative paths are resolved against the <a href="#curdir-tool">current working directory</a>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The absolute local file system path. The path contains file separators for the current platform.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="basename-tool"><a class="anchor" href="#basename-tool"></a>basename tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string basename(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the base name of the given absolute or relative local file system path. The base name of a file or directory is the name of that file or directory. In other words, returns the last part of the given path.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path to the file or directory for which to return the base name. May contain both <code>\</code> and <code>/</code> as file separators. Must not end with <code>\</code> or <code>/</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The base name.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the path ends with <code>\</code> or <code>/</code>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="chdir-tool"><a class="anchor" href="#chdir-tool"></a>chdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool chdir(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Changes the <a href="#curdir-tool">current working directory</a> to the directory referred to by the given path.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path to the new current working directory. Relative paths are resolved against the <a href="#curdir-tool">current working directory</a>. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the given path does not exist.</p></li>
      <li>
       <p>If the given path refers to a file rather than a directory.</p></li>
      <li>
       <p>If it can not be determined whether the given path refers to a file or a directory.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="chfileext-tool"><a class="anchor" href="#chfileext-tool"></a>chfileext tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string chfileext(string path, string? oldext = null, string? newext = null)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Modifies a path such that it ends with a new extension, removing an old extension if it exists.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path to modify. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>oldext</code>
      </dt>
      <dd>
       <p>The old extension that can be removed (case insensitive, no <code>.</code> at the start). Use <code>null</code> to not remove an old extension.</p>
      </dd>
      <dt class="hdlist1">
       <code>newext</code>
      </dt>
      <dd>
       <p>The new extension to use (case sensitive, no <code>.</code> at the start). Use <code>null</code> to not add a new extension.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The changed path, ending with the new extension (if any).</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="curdir-tool"><a class="anchor" href="#curdir-tool"></a>curdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string curdir()</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the script execution’s current working directory, as an absolute local file system path. The path contains file separators for the current platform.</p>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The script execution’s current working directory.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="dirname-tool"><a class="anchor" href="#dirname-tool"></a>dirname tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string dirname(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the absolute directory path of the directory that contains the given file or directory.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute local file system path that refers to a file or directory. May contain both <code>\</code> and <code>/</code> as file separators. Must not end with <code>\</code> or <code>/</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The absolute directory path of the directory that contains the given file or directory. May contain both <code>\</code> and <code>/</code> as file separators.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the given path is not an absolute local file system path.</p></li>
      <li>
       <p>If the given path ends with <code>\</code> or <code>/</code>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="fileext-tool"><a class="anchor" href="#fileext-tool"></a>fileext tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string fileext(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the file extension of the given file, or <code>""</code> if the file has no file extension.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path to the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The file extension, or <code>""</code>.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="hasfileext-tool"><a class="anchor" href="#hasfileext-tool"></a>hasfileext tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool hasfileext(string path, string ext)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Does the given file have the given file extension?</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path to the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>ext</code>
      </dt>
      <dd>
       <p>The file extension to check for (case sensitive, no <code>.</code> at the start).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the file has the given file extension, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="pathjoin-tool"><a class="anchor" href="#pathjoin-tool"></a>pathjoin tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string pathjoin(string... paths)
tool string pathjoin(list string paths)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Joins paths together. If no paths are given, an empty string is returned. If one path is given, the path is returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>paths</code>
      </dt>
      <dd>
       <p>The paths to join together. The first path may be an absolute or relative local file system path. The remaining paths must be relative local file system paths. All paths may contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The joined path. The path contains file separators for the current platform.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="scriptpath-tool"><a class="anchor" href="#scriptpath-tool"></a>scriptpath tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string scriptpath()</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the absolute local file system path to the script being executed. The path contains file separators for the current platform.</p>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The absolute local file system path to the script being executed.</p>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/plcst.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0-M1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>